<?php

/**
 * Ipay88
 * @author Ipay88
 * @package Ipay88\Lib
 */

class ipay88_Indonesia_152
{
    // const URL_PAYMENT_PRODUCTION 				= 'https://payment.ipay88.co.id/epayment/entry.asp';
    // const URL_PAYMENT_SANDBOX    				= 'https://sandbox.ipay88.co.id/epayment/entry.asp';
    const URL_PAYMENT_PRODUCTION                 = 'https://payment.ipay88.co.id/ePayment/WebService/PaymentAPI/Checkout';
    const URL_PAYMENT_SANDBOX                    = 'https://sandbox.ipay88.co.id/ePayment/WebService/PaymentAPI/Checkout';

    const PAYMENT_METHOD_ENABLE                 = 1;
    const PAYMENT_METHOD_DISABLE                = 2;

    const MERCHANT_CODE                         = 'ipay88_merchant_code';
    const MERCHANT_KEY                          = 'ipay88_merchant_key';
    const PAYMENT_MODE                          = 'ipay88_payment_mode';

    // // e-wallet	
    // const PAYMENT_METHOD_OVO					= 63;
    // const PAYMENT_METHOD_LINKAJA 				= 13;
    // Online Credit	
    const PAYMENT_METHOD_KREDIVO                = 55;
    const PAYMENT_METHOD_INDODANA                 = 70;
    const PAYMENT_METHOD_AKULAKU                 = 71;

    // // e-wallet	
    // const PAYMENT_METHOD_OVO_CONFIG				= 'ipay88_ovo_config';
    // const PAYMENT_METHOD_LINKAJA_CONFIG			= 'ipay88_linkaja_config';
    // Online Credit	
    const PAYMENT_METHOD_KREDIVO_CONFIG            = 'ipay88_kredivo_config';
    const PAYMENT_METHOD_INDODANA_CONFIG        = 'ipay88_indodana_config';
    const PAYMENT_METHOD_AKULAKU_CONFIG            = 'ipay88_akulaku_config';

    // // e-wallet	
    // const PAYMENT_METHOD_OVO_CONFIG_LABEL		= 'OVO';
    // const PAYMENT_METHOD_LINKAJA_CONFIG_LABEL	= 'LinkAja';
    // Online Credit	
    const PAYMENT_METHOD_KREDIVO_CONFIG_LABEL    = 'Kredivo';
    const PAYMENT_METHOD_INDODANA_CONFIG_LABEL    = 'Indodana';
    const PAYMENT_METHOD_AKULAKU_CONFIG_LABEL    = 'AkuLaku';

    // function
    public function getBanksConfigs()
    {
        return array(
            // //e-wallet
            // self::PAYMENT_METHOD_OVO_CONFIG,          			
            // self::PAYMENT_METHOD_LINKAJA_CONFIG,
            //Online
            self::PAYMENT_METHOD_KREDIVO_CONFIG,
            self::PAYMENT_METHOD_INDODANA_CONFIG,
            self::PAYMENT_METHOD_AKULAKU_CONFIG,
        );
    }

    public function getFieldsConfigs()
    {
        return array(
            self::MERCHANT_CODE,
            self::MERCHANT_KEY,
            self::PAYMENT_MODE,
            // //e-wallet
            // self::PAYMENT_METHOD_OVO_CONFIG,    
            // self::PAYMENT_METHOD_LINKAJA_CONFIG,  
            //online              
            self::PAYMENT_METHOD_KREDIVO_CONFIG,
            self::PAYMENT_METHOD_INDODANA_CONFIG,
            self::PAYMENT_METHOD_AKULAKU_CONFIG,
        );
    }

    protected $paymentMethod;
    protected $description;
    protected $banks;
    protected $bankKeyConfig;
    protected $paymentId;
    protected $bankName;
    protected $logo;
    protected $imagePath;
    protected $bankEnabled;

    // @return array
    public function getBankEnabled()
    {
        return $this->bankEnabled;
    }

    // @param mixed $bankEnabled
    public function setBankEnabled($bankEnabled)
    {
        $this->bankEnabled = $bankEnabled;
    }

    // @return mixed
    public function getPaymentMethod()
    {
        return $this->paymentMethod;
    }

    // @param mixed $paymentMethod
    public function setPaymentMethod($paymentMethod)
    {
        $this->paymentMethod = $paymentMethod;
    }

    // @return mixed
    public function getBanks()
    {
        return $this->banks;
    }

    // @param mixed $banks
    public function setBanks($banks)
    {
        $this->banks = $banks;
    }

    // @return mixed
    public function getBankKeyConfig()
    {
        return $this->bankKeyConfig;
    }

    // @param mixed $bankKeyConfig
    public function setBankKeyConfig($bankKeyConfig)
    {
        $this->bankKeyConfig = $bankKeyConfig;
    }

    // @return mixed
    public function getPaymentId()
    {
        return $this->paymentId;
    }

    // @param mixed $paymentId
    public function setPaymentId($paymentId)
    {
        $this->paymentId = $paymentId;
    }

    // @return mixed
    public function getBankName()
    {
        return $this->bankName;
    }

    // @param mixed $bankName
    public function setBankName($bankName)
    {
        $this->bankName = $bankName;
    }

    // @return mixed
    public function getLogo()
    {
        return $this->logo;
    }

    // @param mixed $logo
    public function setLogo($logo)
    {
        $this->logo = $logo;
    }

    // @return mixed
    public function getImagePath()
    {
        return $this->imagePath;
    }

    // @param mixed $imagePath
    public function setImagePath($imagePath)
    {
        $this->imagePath = $imagePath;
    }

    // Payment methods, please view technical spec for latest update.
    protected $pMethod = array(
        // //E-WALLET
        // self::PAYMENT_METHOD_OVO_CONFIG  => 
        // array(	'paymentId' => self::PAYMENT_METHOD_OVO,
        //     	'name' 		=> 'OVO',
        //     	'logo' 		=> 'ovo.png'),

        // self::PAYMENT_METHOD_LINKAJA_CONFIG => 
        // array(	'paymentId' => self::PAYMENT_METHOD_LINKAJA,
        //     	'name' 		=> 'LinkAja',
        //         'logo' 		=> 'linkaja.png'),
        //ONLINE
        self::PAYMENT_METHOD_KREDIVO_CONFIG =>
        array(
            'paymentId' => self::PAYMENT_METHOD_KREDIVO,
            'name'         => 'Kredivo',
            'logo'         => 'Kredivo.png'
        ),

        self::PAYMENT_METHOD_INDODANA_CONFIG =>
        array(
            'paymentId' => self::PAYMENT_METHOD_INDODANA,
            'name'         => 'Indodana',
            'logo'         => 'Indodana.png'
        ),

        self::PAYMENT_METHOD_AKULAKU_CONFIG =>
        array(
            'paymentId' => self::PAYMENT_METHOD_AKULAKU,
            'name'         => 'AkuLaku',
            'logo'         => 'AkuLaku.png'
        ),
    );

    // @return array
    public function getPmethod()
    {
        return $this->pMethod;
    }

    // Payment methods, please view technical spec for latest update.
    public $paymentMethods = array(

        // self::PAYMENT_METHOD_OVO_CONFIG  => 
        // array(	'name' 		=> 'OVO',
        //     	'logo' 		=> 'ovo.png'),

        // self::PAYMENT_METHOD_LINKAJA_CONFIG => 
        // array(	'name' 		=> 'LinkAja',
        //         'logo' 		=> 'linkaja.png'),

        self::PAYMENT_METHOD_KREDIVO_CONFIG =>
        array(
            'name'         => 'Kredivo',
            'logo'         => 'Kredivo.png'
        ),

        self::PAYMENT_METHOD_INDODANA_CONFIG =>
        array(
            'name'         => 'Indodana',
            'logo'         => 'Indodana.png'
        ),

        self::PAYMENT_METHOD_AKULAKU_CONFIG =>
        array(
            'name'         => 'AkuLaku',
            'logo'         => 'AkuLaku.png'
        )
    );

    // @param $key
    // @return null
    public function getPaymentMethodInfoByKey($key)
    {
        if (isset($this->pMethod[$key])) {
            return $this->pMethod[$key];
        }

        return null;
    }

    // @param $id
    // @return null
    public function getPaymentMethodInfoById($id)
    {
        if (isset($this->pMethod[$id])) {
            return $this->pMethod[$id];
        }

        return null;
    }

    public function __construct($options = null)
    {
    }

    //payment checkout
    public function getWiget($banks, $description, $imagePath, $auto = false)
    {
        $bankConfigurations = $banks;

        $html = $description . '<br><br>			
		<p class="form-row">
		<label for="ipay88_payment_type">PaymentType
		<span class="required">*</span></label>
		</p>
		
		<div class="payment_method_ipay88">
		<fieldset>
		<legend>Please choose one to pay</legend>';

        if (is_array($bankConfigurations) && count($bankConfigurations)) {
            foreach ($bankConfigurations as $key => $config) {
                if ($config) {
                    $bank = $this->getPaymentMethodInfoByKey($key);

                    if (is_array($bank) && count($bank)) {
                        $paymentId    = isset($bank['paymentId']) ? $bank['paymentId'] : '';
                        $name         = isset($bank['name']) ? $bank['name'] : '';
                        $logo         = $imagePath . DIRECTORY_SEPARATOR . (isset($bank['logo']) ? $bank['logo'] : '');

                        $html .= '<div><label style="margin-bottom:5px;display:inline-flex;align-items:center;">
						<input type="radio" name="ipay88_bank_payment_method" value="' . $paymentId . '">
						<img class="ipay88_bank_payment_method" src="' . $logo . '" alt="' . $name . '" style="float:none; max-width:6.5em; margin-left:1em;"></div>';
                    }
                }
            }
        }

        $html .= '</fieldset></div>';

        return $html;
    }
}
